﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using TMPro;
using UnityEngine.EventSystems;
using UnityEngine.UI;
using System.Linq;

public class DontSortController : MonoBehaviour, IPointerEnterHandler, IPointerExitHandler
{
    public int DontSortAmount;

    //public TextMeshProUGUI buttonUp;
    //public TextMeshProUGUI buttonDown;
    public TextMeshProUGUI dontSortText;

    private void Start()
    {
        DontSortAmount = 0;
        dontSortText = GetComponentInChildren<TextMeshProUGUI>();
        dontSortText.text = "0";
        dontSortText.color = new Color(0.9137255f, 0.8352941f, 0.6745098f, 1f);
        dontSortText.font = BetterInventory.asset.LoadAsset<TMP_FontAsset>("ChineseRocks SDF");
        Shadow s = dontSortText.gameObject.AddComponent<Shadow>();
        s.effectColor = new Color(0.372549f, 0.2235294f, 0.1254902f, 1f);
        s.effectDistance = new Vector2(2, -2);
        s.useGraphicAlpha = true;



        List<Button> bl = GetComponentsInChildren<Button>().ToList();
        foreach (Button b in bl)
        {
            if (b.gameObject.name == "ButtonUp")
            {
                b.onClick.AddListener(OnButtonUp);
            }
            else if (b.gameObject.name == "ButtonDown")
            {
                b.onClick.AddListener(OnButtonDown);
            }
        }
    }


    public void OnButtonUp()
    {
        if (DontSortAmount == int.MaxValue)
            return;
        DontSortAmount++;
        dontSortText.text = DontSortAmount.ToString();
    }

    public void OnButtonDown()
    {
        if (DontSortAmount == 0)
            return;
        DontSortAmount--;
        dontSortText.text = DontSortAmount.ToString();
    }

    public void OnPointerEnter(PointerEventData eventData)
    {
        GameObject.Find("Canvases/_CanvasGame_New/InventoryParent/Inventory_Player/DescriptionBox/ItemDescriptionText").GetComponent<Text>().text = "This number is the amount of inventory slots that are being ignored for sorting.\nThis counts in the same direction as you read this.\nE.g. \"6\" will result in the first row and the first item of the second row being ignored.";
    }

    public void OnPointerExit(PointerEventData eventData)
    {
        GameObject.Find("Canvases/_CanvasGame_New/InventoryParent/Inventory_Player/DescriptionBox/ItemDescriptionText").GetComponent<Text>().text = string.Empty;
    }
}
